Imports System.ServiceProcess
Imports System.Threading

' THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
' IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FIT-
' NESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
' iNTERFACEWARE BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
' IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CON-
' NECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

Public Class ServiceModule
    Inherits System.ServiceProcess.ServiceBase

    ' This has to be static so that we can access it in the ControlCHandler.  See comments
    ' with the ControlCHandler for more detail
    Shared serverInstance As ServerModule

    Public Sub New()
        MyBase.New()
    End Sub

    Protected Overrides Sub OnStart(ByVal args() As String)
        OnStartImp(True)
    End Sub

    Public Sub OnStartImp(ByVal runAsService As Boolean)
        Dim serverThread As Thread
        serverInstance = New ServerModule(runAsService)

        serverThread = New Thread(AddressOf serverInstance.StartService)

        If (runAsService = False) Then
            MakeControlCHandler()
        End If

        serverThread.Start()
        System.Console.WriteLine("Started server thread.")
    End Sub

    Protected Overrides Sub OnStop()
        serverInstance.StopService()
    End Sub

    ' This method has to be static since it is called by the operating system
    ' when the user does control+C in the debug mode for this application.  The serverInstance
    ' is a singleton (i.e. only one instance in the process) which means we can invoke StopService
    ' to stop the service when we are running in debug mode as a console proces
    Public Shared Sub ControlCHandler(ByVal consoleEvent As ConsoleCtrl.ConsoleEvent)
        If (ConsoleCtrl.ConsoleEvent.CTRL_C = consoleEvent) Then
            System.Console.WriteLine("Got Control+C")
            serverInstance.StopService()
        End If
    End Sub

    Private Sub MakeControlCHandler()
        Dim ConsoleControl As New ConsoleCtrl()
        AddHandler ConsoleControl.ControlEvent, AddressOf ControlCHandler
        System.Console.WriteLine("Set up control+C handler")
    End Sub

End Class
